// Server.h : Declaration of the CServer

#ifndef __SERVER_H_
#define __SERVER_H_

#include "resource.h"       // main symbols
#include <mtx.h>

/////////////////////////////////////////////////////////////////////////////
// CServer
class ATL_NO_VTABLE CServer : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CServer, &CLSID_Server>,
	public IObjectControl,
	public IDispatchImpl<IServer, &IID_IServer, &LIBID_CLICKSERVERLib>
{
public:
	CServer()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SERVER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

DECLARE_NOT_AGGREGATABLE(CServer)

BEGIN_COM_MAP(CServer)
	COM_INTERFACE_ENTRY(IServer)
	COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IObjectControl
public:
	STDMETHOD(Activate)();
	STDMETHOD_(BOOL, CanBePooled)();
	STDMETHOD_(void, Deactivate)();

	CComPtr<IObjectContext> m_spObjectContext;

// IServer
public:
	STDMETHOD(Increment)(/*[in,out]*/ int*);
};

#endif //__SERVER_H_
